/* GDB performance test program
 *
 * Copyright (C) 2008  Embecosm Limited
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * $Id: perf.c 331 2009-03-12 17:01:48Z jeremy $
 */

#include "utils.h"


int a (int  m,
       int  n)
{
  if (0 == m)
    {
      return  n + 1;
    }
  else if (0 == n)
    {
      return a (m - 1, 1);
    }
  else
    {
      return a (m - 1, a (m, n - 1));
    }
}

main()
{
  int  i;
  int  j;

  for (i = 0; i <= 3; i++)
    {
      for (j = 0; j <= (6 - i); j++)
	{
	  simputs ("Ackerman (");
	  simputn (i);
	  simputs (", ");
	  simputn (j);
	  simputs (") = ");
	  simputn (a (i, j));
	  simputs ("\n");
	}
    }

  simexit (0);
}
